// Copyright (C) 2009 by Oussama Kanoun.
//
// This file is part of the hpp-localstepper.
//
// hpp-localstepper is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// hpp-localstepper is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with hpp-localstepper.  If not, see <http://www.gnu.org/licenses/>.

/**

   \mainpage

   \section intro Introduction

   This package implements local motion planning for a humanoid
   robot. The main algorithm is composed of two phases and makes use of
   a virtual kinematic structure composed of successive feet of the
   robot moving in the plane and the whole humanoid robot at the end of the 
   structure.
     \li In the first phase, a configuration of the kinematic structure is 
         computed using a gradient descent subject to linear inequality
	 constraints. 
     \li In the second phase, the position of the feet of the virtual structure
         define steps, while the configuration of the humanoid robot defines
	 geometric tasks to be achieved at the end of the motion.

   \image html between-feet.png "Generation of steps for grasping an object between the feet."

*/
