/*
  Copyright 2009 CNRS-LAAS

  Author: Oussama Kanoun
*/
#ifndef HPP_LOS_FEET_PROJECTION_TASK_H
#define HPP_LOS_FEET_PROJECTION_TASK_H

#include "hpp/localstepper/task/task.hh"
class ChppLosRobotLink;
class ChppGikStandingRobot;
/**
A task to project a foot of a CjrlHumanoidDynamicRobot on the ground. This is intended for use as a permanent constraint to ChppCentipede object.
\ingroup tasks
 */
class ChppLosFeetProjectionTask: public ChppLosTask
{
    public:
       /**
        \brief Constructor
        */
        ChppLosFeetProjectionTask(ChppLosCentipede& inCentipede, ChppLosRobotLink& inRobotLink);
        /**
        \brief Inherited. Returns true;
         */
        bool isEqualityTask() const {return true;};
        /**
        \brief Inherited
         */
        void computeDifferentialSystem();
        /**
        \brief Inherited
         */
        const vectorN& currentValue();
        
    private:
        
        void equivAsymMat3 ( const vector3d& inVec, matrixNxP& outMat );
        void crossProd3 ( const vector3d& v1, const vector3d& v2, vector3d& retV );
        ChppLosRobotLink* attRobotLink;
        ChppGikStandingRobot* attStandingRobot;
        vectorN tempOmega,tempPos;
        matrixNxP tempRot, jacF;
        matrix3d m3;
        vector3d locVec;
        matrixNxP matOP, matOT,matOTOP;
        vector3d cross;
        double attLeftAnkleHeight,attRightAnkleHeight;
};

#endif
