/*
  Copyright 2009 CNRS-LAAS

  Author: Oussama Kanoun
*/
#ifndef HPP_LOS_COM_TASK_H
#define HPP_LOS_COM_TASK_H

#include "hpplocalstepper/tasks/hppLosTask.hh"
class ChppLosRobotLink;


/**
A task to move te center of mass
\ingroup tasks
 */
class ChppLosComTask: public ChppLosTask
{
    public:
       
        /**
        \brief Constructor
         */
        ChppLosComTask(ChppLosCentipede& inCentipede, ChppLosRobotLink& inRobotLink, double inX, double inY);
        /**
        \brief Set target point's X and Y world coordinates
         */
        void targetXY(double inX, double inY);
        /**
        \brief Set the maximum linear velocity of the reference point
         */
        void maxVelocityNorm(double inMV);
        /**
        \brief Return true
         */
        bool isEqualityTask() const {return true;};
        /**
        \brief Inherited
         */
        void computeDifferentialSystem();
        /**
        \brief Inherited
         */
        const vectorN& currentValue();

    private:
        bool resize();
        ChppLosRobotLink* attRobotLink;
        CjrlJoint* attJoint;
        double  attTargetX,attTargetY;
        double attMaxVelocity;
        matrixNxP attTempJacobian;
};

#endif
